<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               :upload-after="uploadAfter"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.ads_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/platform/ads";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "标题",
              prop: "title",
              rules: [{
                required: true,
                message: "请输入主标题",
                trigger: "blur"
              }]
            },
            {
              label: "广告类型",
              prop: "typeDisplayName",
              display: false,
              width: 100,
            },
            {
              label: "广告类型",
              prop: "type",
              type: "select",
              dicUrl: "/api/blade-system/dict-biz/dictionary?code=ads_type",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              dataType: "number",
              search: true,
              hide: true,
              rules: [{
                required: true,
                message: "请选择类型",
                trigger: "blur"
              }]
            },
            {
              label: "跳转类型",
              prop: "skipType",
              type: "select",
              dicUrl: "/api/blade-system/dict-biz/getEnumDict?enumName=SkipTypeEnum",
              props: {
                label: "name",
                value: "value"
              },
              dataType: "number",
              search: true,
              hide: true,
              rules: [{
                required: true,
                message: "请选择跳转类型",
                trigger: "blur"
              }]
            },
            {
              label: "是否启用",
              prop: "isEnabledDisplayName",
              display: false,
              width: 100,
            },
            {
              label: "是否启用",
              prop: "isEnabled",
              type: "select",
              dicUrl: "/api/blade-system/dict/dictionary?code=yes_no",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              dataType: "number",
              search: true,
              hide: true,
              rules: [{
                required: true,
                message: "请选择是否启用",
                trigger: "blur"
              }]
            },
            {
              label: "团购",
              prop: "grouponId",
              addDisplay: false,
              editDisplay: false,
              viewDisplay: false,
              hide: true,
              type: "select",
              dicUrl: "/api/groupon/groupon/list?status=1&auditStatus=1&current=1&size=100",
              props: {
                label: "mainTitle",
                value: "id"
              },
              dicFormatter: function (res) {
                return res.data.records;
              },
              rules: [{
                required: true,
                message: "请选择团购",
                trigger: "blur"
              }]
            },
            {
              label: "文章",
              prop: "articleId",
              addDisplay: false,
              editDisplay: false,
              viewDisplay: false,
              hide: true,
              type: "select",
              dicUrl: "/api/platform/article/list?current=1&size=100",
              props: {
                label: "title",
                value: "id"
              },
              dicFormatter: function (res) {
                return res.data.records;
              },
              rules: [{
                required: true,
                message: "请选择团购",
                trigger: "blur"
              }]
            },
            {
              label: "排序",
              prop: "sort",
              width: 100,
              rules: [{
                required: true,
                message: "请输入排序",
                trigger: "blur"
              }],
              type: "number"
            },
            {
              label: "广告图片",
              prop: "imageUrl",
              type: 'upload',
              addDisplay: false,
              editDisplay: false,
              listType: 'picture-img',
              span: 24,
            },
            {
              label: '广告图片',
              prop: 'attachUrl',
              type: 'upload',
              listType: 'picture-img',
              loadText: '上传中，请稍等',
              accept: 'image/png, image/jpeg',
              fileSize: 500,
              tip: '建议尺寸：750×420；只能上传jpg/png文件，且不超过500kb',
              span: 24,
              hide: true,
              viewDisplay: false,
              propsHttp: {
                res: 'data',
                url: 'link',
              },
              action: "/api/blade-resource/oss/endpoint/put-file-attach"
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.ads_add, false),
          viewBtn: this.vaildData(this.permission.ads_view, false),
          delBtn: this.vaildData(this.permission.ads_delete, false),
          editBtn: this.vaildData(this.permission.ads_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    created() {
      this.option.column[3].change = function (column) {
        const content = this.findObject(this.option.column, "articleId");
        const dataId = this.findObject(this.option.column, "grouponId");
        if (column.value === 1) {
          this.$set(content, 'addDisplay', false)
          this.$set(content, 'editDisplay', false)
          this.$set(content, 'viewDisplay', false)
          this.$set(dataId, 'addDisplay', false)
          this.$set(dataId, 'editDisplay', false)
          this.$set(dataId, 'viewDisplay', false)
        }
        if (column.value === 2) {//文章
          this.$set(content, 'addDisplay', true)
          this.$set(content, 'editDisplay', true)
          this.$set(content, 'viewDisplay', true)
          this.$set(dataId, 'addDisplay', false)
          this.$set(dataId, 'editDisplay', false)
          this.$set(dataId, 'viewDisplay', false)
        }
        if (column.value === 3) {// 团购
          this.$set(content, 'addDisplay', false)
          this.$set(content, 'editDisplay', false)
          this.$set(content, 'viewDisplay', false)
          this.$set(dataId, 'addDisplay', true)
          this.$set(dataId, 'editDisplay', true)
          this.$set(dataId, 'viewDisplay', true)
        }
      }.bind(this);
    },
    methods: {
      rowSave(row, done, loading) {
        if (row.skipType == 2) {
          row.dataId = row.articleId;
        }
        if (row.skipType == 3) {
          row.dataId = row.grouponId;
        }
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        if (row.skipType == 2) {
          row.dataId = row.articleId;
        }
        if (row.skipType == 3) {
          row.dataId = row.grouponId;
        }
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
            this.form.attachUrl = this.form.imageUrl;
            if (this.form.skipType == 2) {
              this.form.articleId = this.form.dataId;
            }
            if (this.form.skipType == 3) {
              this.form.grouponId = this.form.dataId;
            }
          });
        }
        done();
      },
      uploadAfter(res, done, loading, column) {
        this.form.imageUrl = res.link;
        done()
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
